<template>
  <base-popup class="auth-modal">
    <div id="authForm" class="auth-modal-body">
      <div id="nav-tabContent" class="tab-list">
        <form
          class="tab-pane fade active show"
          role="tabpanel"
          @submit.prevent="changeNickname"
        >
          <div class="auth-modal-content">
            <div class="mb-3">
              <input
                v-model="controls.username"
                type="text"
                name="nickname"
                placeholder="Ваш никнейм"
                autocomplete="username"
              />
            </div>
            <div class="mb-3">
              <base-input
                v-model="controls.current_password"
                component="password"
                placeholder="Ваш пароль"
                autocomplete="new-password"
              />
            </div>
            <div class="mb-5">
              <base-input
                v-model="controls.retryPassword"
                component="password"
                placeholder="Повторите пароль"
                autocomplete="new-password"
              />
            </div>
            <button
              class="btn btn-primary w-100 d-block"
              type="submit"
              :disabled="loading || $v.controls.$invalid"
            >
              Сменить
            </button>
          </div>
        </form>
      </div>
    </div>
  </base-popup>
</template>

<script>
import required from 'vuelidate/lib/validators/required'
import sameAs from 'vuelidate/lib/validators/sameAs'

import { mapState } from 'vuex'
import { NICKNAME } from '@/constants/popups'
import { TypesPopup } from '@/constants/store.types'
export default {
  props: {
    username: {
      type: String,
      required: false,
      default: '',
    },
  },
  data() {
    return {
      controls: {
        username: this.username,
        current_password: '',
        retryPassword: '',
      },
    }
  },
  computed: {
    ...mapState({
      loading: (state) => state.loading,
    }),
  },
  methods: {
    changeNickname() {
      this.$store
        .dispatch(`user/changeProfile`, this.controls)
        .then((newUserData) => {
          this.$auth.$storage.setState('user', newUserData)
          this.$store.commit(TypesPopup.mutations.CLOSE_POPUP, NICKNAME)
        })
    },
  },
  validations: {
    controls: {
      username: {
        required,
      },
      current_password: {
        required,
      },
      retryPassword: {
        sameAsPassword: sameAs('current_password'),
      },
    },
  },
}
</script>

<style></style>
